<?php
/*
Plugin Name: Quasar Form add-on for WooCommerce
Plugin URI: https://quasar-form.com
Description: Allows you to use forms from the Quasar Form plugin as quick order forms in Woocommerce 
Version: 1.2
Author: nucleus_genius

*/




//disable free version
function quasar_form_woo_deactivate_free() {
if ( is_plugin_active('quasar-form-woo-add-on-pro/quasar-form-shop-main.php') ) {
    
        deactivate_plugins( 'quasar-form-woo-add-on/quasar-form-shop-main.php');
        
    }
}
add_action( 'admin_init', 'quasar_form_woo_deactivate_free' );

//v
define( 'quasar_form_shop_free_version', '1.2' );

// add button admin
function quasar_form_shop_main_addpanel_free() {
   add_menu_page('Quasar-form-pro', 'QF for Woo', 'manage_options', 'quasar-form-woo-add-on/admin.php', '', plugins_url( '/assets/img/icon2.png', __FILE__  ));
}
add_action('admin_menu', 'quasar_form_shop_main_addpanel_free' ); 



//creating a database when activating the plugin
function quasar_form_shop_free_addtable (){
    
	global $wpdb;
    $table_name = $wpdb->base_prefix . 'quasarform_shop';
    $sql = "CREATE TABLE $table_name (
			id int(11) NOT NULL AUTO_INCREMENT,
			mainparams mediumtext NOT NULL,
			UNIQUE KEY id (id)
			);";
	require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
	dbDelta( $sql );
	
    //default option
    $quasar_form_option = $wpdb->get_results( "SELECT * FROM {$wpdb->base_prefix}quasarform_shop", ARRAY_A  );
    if ( count($quasar_form_option) == 0 ) {
        $wpdb->query( $wpdb->prepare( "INSERT INTO {$wpdb->base_prefix}quasarform_shop ( `mainparams` ) VALUES ( %s )",  '{"dataForm":"Select form","dataTextButton":"Buy one click","dataPosition":"variant3","dataPosition2":"variant1","dataIdForm":"","dataCreateOrder":"yes","dataTextPrice":"","dataTextQuantity":"","dataShowStockZero":"yes","dataPositionCurrency":"left","dataFirstName":"0","dataLasttName":"0","dataEmail":"0","dataPhone":"0","dataCompany":"0","dataAddress":"0","dataCity":"0","dataState":"0","dataPostcode":"0","dataCountry":"US","dataComment":"0","dataQuanity":"0","dataShowImg":"yes","dataShowPrice":"yes","dataShowQuanity":"yes","dataShowName":"yes","dataFontName":"16px","dataColorName":"#262626","dataFontHeading":"14px","dataColorHeading":"#262626","dataFontInput":"14px","dataColorSections":"#262626","dataBackgroundSections":"#f1f1f1","dataBorderSections":"#d9d9d9","dataButtonAlign":"center","dataButtonMagrinCategory":"0px;0px;10px;0px","dataButtonMagrinCart":"0px;0px;0px;0px"}'));
    }
	

}
register_activation_hook( __FILE__, 'quasar_form_shop_free_addtable' );




//lang dirname
function quasar_form_shop_free_lang() {
	load_plugin_textdomain( 'quasar-form-shop', false, dirname( plugin_basename( __FILE__ ) ) . '/lang/' ); 
}
add_action( 'plugins_loaded', 'quasar_form_shop_free_lang' );


//frontend style and script
function quasar_form_shop_free_frontend(){
    
    wp_enqueue_style('quasar-woo-frontend-style', plugins_url( '/assets/css/frontend.css', __FILE__ ), array(), quasar_form_shop_free_version);
    
    //add frontend js
    wp_enqueue_script('quasar-woo-frontend-script',plugins_url( '/assets/js/frontend.js', __FILE__ ), array('jquery') , quasar_form_shop_free_version, true);
    
    
    wp_localize_script('quasar-woo-frontend-script', 'params',
        array(
            'ajaxurlq' => admin_url('admin-ajax.php'),
            'nonce' => wp_create_nonce('nonce-frontend-q')
        )
    ); 
    
    
}
add_action('wp_footer','quasar_form_shop_free_frontend');



//add script admin page 
function quasar_form_shop_free_admin_script( $hook ){
    if( $hook != 'quasar-form-woo-add-on/admin.php' ) return;
    
    //hide notifications
    remove_all_actions('admin_notices');

    //admin
    wp_register_script('quasar-woo-admin-script', plugins_url( '/assets/js/admin.js', __FILE__ ), array(), quasar_form_shop_free_version );
    wp_enqueue_script('quasar-woo-admin-script');
    
    //admin fa fa
    wp_enqueue_style('Quasar-form-font-awesome', plugins_url( '/assets/font-awesome/css/font-awesome.min.css', __FILE__ ), array(), quasar_form_shop_free_version ); 
    
    
    //admin ajax
    wp_localize_script('quasar-woo-admin-script', 'params',
        array(
            'ajaxurl' => admin_url('admin-ajax.php'),
            'nonce' => wp_create_nonce('q-ajax-nonce')
        )
    ); 

    //admin css
    wp_enqueue_style('Quasar-form-admin-style', plugins_url( '/assets/css/admin.css', __FILE__ ), array(), quasar_form_shop_free_version );
    
    wp_enqueue_script('jquery-color');
    wp_enqueue_style('wp-color-picker');
    wp_enqueue_script('wp-color-picker');
    wp_enqueue_script('iris');
    wp_enqueue_media();
    //admin alfa color picker
    wp_enqueue_style( 'Quasar-form-color-picker-alpha' );
    wp_enqueue_script( 'Quasar-form-color-picker-alpha',  plugins_url( '/lib/wp-color-picker-alpha-master/dist/wp-color-picker-alpha.min.js', __FILE__ ) , array( 'wp-color-picker' ) , quasar_form_shop_free_version , true);
    
    //color localization
    wp_localize_script('Quasar-form-color-picker-alpha', 'localizationColor',
        array(
            'color' => esc_html__('Select Color','quasar-form-shop'),
            'clear' => esc_html__('Clear','quasar-form-shop'),
        )
    ); 
  
}
add_action('admin_enqueue_scripts','quasar_form_shop_free_admin_script');



if( !is_admin() ){
	global $wpdb;
    $quasar_form_shop = $wpdb->get_results( "SELECT * FROM {$wpdb->base_prefix}quasarform_shop WHERE id='1'", ARRAY_A  );
    foreach($quasar_form_shop as $row){
        $array_option = json_decode($row['mainparams'], true ); 
    }
}


//add button
function quasar_form_shop_free_add_button($q){
    global $array_option,$product,$post;
    $setting = $array_option['dataShowImg'].';'.$array_option['dataShowPrice'].';'.$array_option['dataShowQuanity'].';'.$array_option['dataShowName'].';'.$array_option['dataFontName'].';'.$array_option['dataColorName'].';'.$array_option['dataFontHeading'].';'.$array_option['dataColorHeading'].';'.$array_option['dataFontInput'].';'.$array_option['dataColorSections'].';'.$array_option['dataBackgroundSections'].';'.$array_option['dataBorderSections'].';'.$array_option['dataPositionCurrency'] ;
    
    //if stock 0 not show
    if ( $array_option['dataShowStockZero'] == 'not' ) {
        if ( !$product->is_in_stock() ){ return; }
    }
    
    //simple product
    if ( $product->is_type( 'simple' ) ) {
        $currency = get_woocommerce_currency();
        $currency = get_woocommerce_currency_symbol( $currency = $currency );
        
        //class button cart
        if ( $q == 1){
            $margin = explode(';', $array_option['dataButtonMagrinCart']);
            $class = 'cart-button-q';
            $style = 'margin-left:'.$margin['0'].'; margin-right:'.$margin['1'].'; margin-top:'.$margin['2'].'; margin-bottom:'.$margin['3'];
            
        }
        //category
        else {
            $margin = explode(';', $array_option['dataButtonMagrinCategory']);
            $class = 'category-button-q';
            $style = 'margin-left:'.$margin['0'].'; margin-right:'.$margin['1'].'; margin-top:'.$margin['2'].'; margin-bottom:'.$margin['3'];
            
            if ( $array_option['dataButtonAlign'] =='left' ){ $class.=' left-align-c-b-q';}
            else if ( $array_option['dataButtonAlign'] =='right' ){ $class.=' right-align-c-b-q';}
            else if ( $array_option['dataButtonAlign'] =='center' ){ $class.=' center-align-c-b-q';}
        }
        
        return '<div class="wrap-button-quasar-woo '.esc_attr( $class ).'" style="'.esc_attr( $style ).'" data-id="'.esc_attr( $product->get_id() ).'" data-name="'.esc_attr( $product->get_name() ).'" data-price="'.esc_attr( $product->get_price() ).'" data-img="'.esc_url( get_the_post_thumbnail_url($post->ID) ).'" data-currency="'.esc_attr( $currency ).'" data-setting="'.esc_attr( $setting ).'" data-h-1="'.esc_html( $array_option['dataTextPrice'] ).'" data-h-2="'.esc_html( $array_option['dataTextQuantity'] ).'"  data-qua="'.esc_attr( $array_option['dataQuanity'] ).'">'.do_shortcode( '[formaQ id="'.esc_attr($array_option['dataIdForm']).'" type="popup" align="center" text="'.esc_html($array_option['dataTextButton']).'" ]' )."</div>";
    }
    
}




//add button position 1
add_action( 'woocommerce_after_add_to_cart_button', 'quasar_form_shop_free_add_button_1', 25 );
function quasar_form_shop_free_add_button_1(){
    global  $array_option;
    if ( $array_option['dataPosition']== 'variant1' ){
        echo quasar_form_shop_free_add_button(1);
    }
}


//add button position 2
add_action( 'woocommerce_before_quantity_input_field', 'quasar_form_shop_free_add_button_2', 25 );
function quasar_form_shop_free_add_button_2(){
    global  $array_option;
    if ( $array_option['dataPosition']== 'variant2' ){
        echo quasar_form_shop_free_add_button(1);
    }
}

//add button position 3 or if stock 0
add_action( 'woocommerce_single_product_summary', 'quasar_form_shop_free_add_button_3', 25 );
function  quasar_form_shop_free_add_button_3(){
    global  $array_option,$product;
    if ( $array_option['dataPosition']== 'variant3' || ( $array_option['dataShowStockZero'] == 'yes' &&  $array_option['dataPosition']!= 'variant4' &&  !$product->is_in_stock()  && $product->is_type( 'simple' ) ) ){
        echo quasar_form_shop_free_add_button(1);
    }
}

//add button position 4
add_action( 'woocommerce_product_meta_end', 'quasar_form_shop_free_add_button_4', 25);
function quasar_form_shop_free_add_button_4(){
    global  $array_option;
    if ( $array_option['dataPosition']== 'variant4' ){
        echo quasar_form_shop_free_add_button(1);
    }
}


//archive & category position 1
add_action( 'woocommerce_after_shop_loop_item', 'quasar_form_shop_free_archive_button_1', 25 );
function quasar_form_shop_free_archive_button_1(){
    global  $array_option,$product;
    if ( $array_option['dataPosition2']== 'variant1' ){
        if ( $array_option['dataShowStockZero'] == 'yes' ){
            echo quasar_form_shop_free_add_button(2);
        }
        else { 
            //stock != 0
            if ( $product->is_in_stock() ) {
                echo quasar_form_shop_free_add_button(2) ;
            }
        }
    }
}

//archive & category position 2
add_action( 'woocommerce_before_shop_loop_item', 'quasar_form_shop_free_archive_button_2', 25 );
function quasar_form_shop_free_archive_button_2(){
    global  $array_option,$product;
    if ( $array_option['dataPosition2']== 'variant2' ){
        if ( $array_option['dataShowStockZero'] == 'yes' ){
            echo quasar_form_shop_free_add_button(2);
        }
        else { 
            //stock != 0
            if ( $product->is_in_stock() ) {
                echo quasar_form_shop_free_add_button(2) ;
            }
        }
    }
}



add_action('wp_ajax_save_woo_setting', 'quasar_form_free_shop_save');

add_action('wp_ajax_send_woo_form', 'quasar_form_shop_free_send_woo_form');
add_action('wp_ajax_nopriv_send_woo_form', 'quasar_form_shop_free_send_woo_form'); 



// save/update form
function quasar_form_free_shop_save(){

    check_ajax_referer( 'q-ajax-nonce', 'nonce_code' );
    
    // Stop if the current user is not an admin or do not have administrative access
	if( ! current_user_can( 'manage_options' ) ) {
		die();
	}


    $quasar_woo_save_array = array(
        'dataForm' => sanitize_text_field( $_POST['dataForm'] ),
        'dataTextButton' => sanitize_text_field( $_POST['dataTextButton'] ),
        'dataPosition' => sanitize_text_field ( $_POST['dataPosition'] ),
        'dataPosition2' => sanitize_text_field ( $_POST['dataPosition2'] ),
        'dataIdForm' => sanitize_text_field ( $_POST['dataIdForm'] ),
        'dataCreateOrder' => sanitize_text_field ( $_POST['dataCreateOrder'] ),
        'dataTextPrice' => sanitize_text_field ( $_POST['dataTextPrice'] ),
        'dataTextQuantity' => sanitize_text_field ( $_POST['dataTextQuantity'] ),
        'dataShowStockZero' => sanitize_text_field ( $_POST['dataShowStockZero'] ),
        'dataPositionCurrency' => sanitize_text_field ( $_POST['dataPositionCurrency'] ),
      
        
        'dataFirstName' => sanitize_text_field ( $_POST['dataFirstName'] ),
        'dataLasttName' => sanitize_text_field ( $_POST['dataLasttName'] ),
        'dataEmail' => sanitize_text_field ( $_POST['dataEmail'] ),
        'dataPhone' => sanitize_text_field ( $_POST['dataPhone'] ),
        'dataCompany' => sanitize_text_field ( $_POST['dataCompany'] ),
        'dataAddress' => sanitize_text_field ( $_POST['dataAddress'] ),
        'dataCity' => sanitize_text_field ( $_POST['dataCity'] ),
        'dataState' => sanitize_text_field ( $_POST['dataState'] ),
        'dataPostcode' => sanitize_text_field ( $_POST['dataPostcode'] ),
        'dataCountry' => sanitize_text_field ( $_POST['dataCountry'] ),
        'dataComment' => sanitize_text_field ( $_POST['dataComment'] ),
        'dataQuanity' => sanitize_text_field ( $_POST['dataQuanity'] ),
        
        'dataShowImg' => sanitize_text_field ( $_POST['dataShowImg'] ),
        'dataShowPrice' => sanitize_text_field ( $_POST['dataShowPrice'] ),
        'dataShowQuanity' => sanitize_text_field ( $_POST['dataShowQuanity'] ),
        'dataShowName' => sanitize_text_field ( $_POST['dataShowName'] ),
        
        'dataFontName' => sanitize_text_field ( $_POST['dataFontName'] ),
        'dataColorName' => sanitize_text_field ( $_POST['dataColorName'] ),
        'dataFontHeading' => sanitize_text_field ( $_POST['dataFontHeading'] ),
        'dataColorHeading' => sanitize_text_field ( $_POST['dataColorHeading'] ),
        'dataFontInput' => sanitize_text_field ( $_POST['dataFontInput'] ),
        'dataColorSections' => sanitize_text_field ( $_POST['dataColorSections'] ),
        'dataBackgroundSections' => sanitize_text_field ( $_POST['dataBackgroundSections'] ),
        'dataBorderSections' => sanitize_text_field ( $_POST['dataBorderSections'] ),
        'dataButtonAlign' => sanitize_text_field ( $_POST['dataButtonAlign'] ),
        'dataButtonMagrinCategory' => sanitize_text_field ( $_POST['dataButtonMagrinCategory'] ),
        'dataButtonMagrinCart' => sanitize_text_field ( $_POST['dataButtonMagrinCart'] ),
        
     
    );
    

    $quasar_woo_save_array = wp_json_encode( $quasar_woo_save_array );
    $quasar_woo_save_array = str_replace( 'ZapETayA',  '\u0027', $quasar_woo_save_array );
    

    global $wpdb;
    $update_check = $wpdb->get_results("SELECT * FROM {$wpdb->base_prefix}quasarform_shop ", ARRAY_A  );

    //updating the current form
    $wpdb->update( "{$wpdb->prefix}quasarform_shop",
        [ 'mainparams' => $quasar_woo_save_array ],
	    [ 'id' => '1' ],
	    [ '%s' ],
	    [ '%s' ]
	 );
}




function quasar_form_shop_free_send_woo_form(){
    
    check_ajax_referer( 'nonce-frontend-q', 'nonce_code' );
    
    //data from bd
    global $wpdb,$product,$array_option;
    $quasar_form_shop = $wpdb->get_results( "SELECT * FROM {$wpdb->base_prefix}quasarform_shop WHERE id='1'", ARRAY_A  );
    foreach($quasar_form_shop as $row){
        
        $array_option = json_decode($row['mainparams'], true ); 
    }
    //data from form
    $id_product = sanitize_text_field( $_POST['dataIdProduct'] );
    $quanity_defoult = sanitize_text_field( $_POST['dataQuantity'] );

    $object = sanitize_text_field( $_POST['dataSend'] );
    $object = explode( ',', $object);
    
    $arrayDataOrder = array(
        'FirstName' => '',
        'LastName' => '',
        'Company' => '',
        'Email' => '',
        'Phone' => '',
        'Address' => '',
        'City' => '',
        'State' => '',
        'Postcode' => '',
        'Country' => '',
        'Comment' => '',
        'Quanity' => '1',
        
    );
    $quanity = 0;

    foreach($object as $value){
        $value = explode(';', $value);
        if ( $array_option['dataFirstName'] == $value['0'] ){ $arrayDataOrder['FirstName'] = $value['2']; }
        if ( $array_option['dataLasttName'] == $value['0'] ){ $arrayDataOrder['LastName'] = $value['2']; }
        if ( $array_option['dataCompany'] == $value['0'] ){ $arrayDataOrder['Company'] = $value['2']; }
        if ( $array_option['dataEmail'] == $value['0'] ){ $arrayDataOrder['Email'] = $value['2']; }
        if ( $array_option['dataPhone'] == $value['0'] ){ $arrayDataOrder['Phone'] = $value['2']; }
        if ( $array_option['dataAddress'] == $value['0'] ){ $arrayDataOrder['Address'] = $value['2']; }
        if ( $array_option['dataCity'] == $value['0'] ){ $arrayDataOrder['City'] = $value['2']; }
        if ( $array_option['dataState'] == $value['0'] ){ $arrayDataOrder['State'] = $value['2']; }
        if ( $array_option['dataPostcode'] == $value['0'] ){ $arrayDataOrder['Postcode'] = $value['2']; }
        if ( $array_option['dataComment'] == $value['0'] ){ $arrayDataOrder['Comment'] = $value['2']; }
        //quanity
        if ( $array_option['dataQuanity'] == $value['0'] ){ $arrayDataOrder['Quanity'] = $value['2'];  $quanity++; }
  
    }
    //quanity defoult
    if ( $quanity == 0 ){
        $arrayDataOrder['Quanity'] = $quanity_defoult; 
    }
    //country
    $arrayDataOrder['Country'] = $array_option['dataCountry'];
    

	//create order
	if ( $array_option['dataCreateOrder'] !='not') {
	     $address = array(
            'first_name' => $arrayDataOrder['FirstName'],
            'last_name'  => $arrayDataOrder['LastName'],
            'company'    => $arrayDataOrder['Company'],
            'email'      => $arrayDataOrder['Email'],
            'phone'      => $arrayDataOrder['Phone'],
            'address_1'  => $arrayDataOrder['Address'],
            'address_2'  => '', 
            'city'       => $arrayDataOrder['City'],
            'state'      => $arrayDataOrder['State'],
            'postcode'   => $arrayDataOrder['Postcode'],
            'country'    => $arrayDataOrder['Country']
        );


        $order = wc_create_order();
        $order->add_product( wc_get_product( $id_product ), (int)$arrayDataOrder['Quanity'] ); //(get_product with id and next is for quantity)
        $order->set_address( $address, 'billing' );
        $order->set_address( $address, 'shipping' );
        $order->set_customer_note( $arrayDataOrder['Comment']  ); //comment
        $order->calculate_totals();
	}

}

